#!/bin/bash

. /home/radek/.bash_profile

LOG_NAME=/var/tmp/oracle/generate_images.log;

PREVIOUS_DAY=$(date -d '-1 day' +'%Y-%m-%d')

#cn=T1HP42OL
array_cn=("HAL_LODZ" "T1HP42OL");

for cn in "${array_cn[@]}"
do
  echo "------------------------- $PREVIOUS_DAY $cn-------------------------" >> $LOG_NAME
  if [ ! -d /var/www/html/workload_stats/$PREVIOUS_DAY/$cn ]; then
   mkdir -p /var/www/html/workload_stats/$PREVIOUS_DAY/$cn
   echo "Zakładam katalog /var/www/html/workload_stats/$PREVIOUS_DAY/$cn" >> $LOG_NAME	
  fi;

  DEST_PATH=/var/www/html/workload_stats/$PREVIOUS_DAY/$cn

  /usr/bin/perl drawPie.pl workload.png triangle.vertices Workload $cn /tmp/inputData.txt details $cn >> $LOG_NAME;
  /usr/bin/perl drawPie.pl workloadsummary.png triangle.vertices Workload $cn /tmp/inputData.txt summary $cn >> $LOG_NAME;

  mv workload.png $DEST_PATH
  mv workloadsummary.png $DEST_PATH
  mv details_${cn}_${PREVIOUS_DAY}.csv /var/www/html/workload_stats/tabular
  mv summary_${cn}_${PREVIOUS_DAY}.csv /var/www/html/workload_stats/tabular
  rm -f triangle.vertices
done;
