-- create tablespace WORKLOAD datafile '' size 2G ;
-- CREATE USER WORKLOAD_MON identified by zebra12 default tablespace WORKLOAD quota unlimited on WORKLOAD;
-- Grant connect,resource,select any dictionary, manage scheduler,scheduler_admin to WORKLOAD_MON;
--CREATE TABLE SESS_BY_USER_STAT_DET_DAILY 
--  (DAY DATE, SID NUMBER, VALUE NUMBER, USERNAME VARCHAR2(100), RESOURCE_CONSUMER_GROUP VARCHAR2(100));
-- CREATE TABLE USER_CORPORATION (USERNAME VARCHAR2(100), CORPORATION VARCHAR2(1000));
-- DROP TABLE CPU_BY_RSRCGRP_USER_DAY
-- CREATE TABLE CPU_BY_RSRCGRP_USER_DAY (RESOURCE_CONSUMER_GROUP VARCHAR2(100),USERNAME VARCHAR2(100),DAY DATE, VALUE NUMBER);
-- CREATE TABLE CORPORATIONS(ID NUMBER,CORPORATION VARCHAR2(1000), constraint PK_CORP PRIMARY KEY(ID,CORPORATION));
-- ALTER TABLE CORPORATIONS ADD CONSTRAINT U_CORP UNIQUE (ID);
-- CREATE TABLE USER_CORPORATION_NEW (USERNAME VARCHAR2(100), ID NUMBER, CONSTRAINT FK_UC FOREIGN KEY(ID) REFERENCES CORPORATIONS(ID), 
-- CONSTRAINT PK_UC PRIMARY KEY (USERNAME,ID)) ;

-- DROP TABLE CPU_BY_RSRCGRP_USER_HIST
-- CREATE TABLE CPU_BY_RSRCGRP_USER_HIST (RESOURCE_CONSUMER_GROUP VARCHAR2(100),USERNAME VARCHAR2(100),DAY DATE, VALUE NUMBER);


-- create index sbusdd_day_char on SESS_BY_USER_STAT_DET_DAILY(TO_CHAR(DAY,'YYYY-MM-DD')) ONLINE;
-- create index sbusdd_day_char_date  on SESS_BY_USER_STAT_DET_DAILY(TO_DATE(TO_CHAR(DAY,'YYYY-MM-DD'),'YYYY-MM-DD')) ONLINE;
-- create index sbusdd_sid_user on SESS_BY_USER_STAT_DET_DAILY(SID,USERNAME) ONLINE;

-- create index CBRUD_USER on CPU_BY_RSRCGRP_USER_DAY(USERNAME);
-- create index CBRUD_DAY on CPU_BY_RSRCGRP_USER_DAY(DAY);
-- create index UC_USER on USER_CORPORATION(USERNAME);
-- create index UC_CORP on USER_CORPORATION(ID);

CREATE OR REPLACE PROCEDURE GATHER_CPU_STATS_BY_SESSION AS
--V$RSRC_CONS_GROUP_HISTORY
--V$RSRC_CONSUMER_GROUP
--delete from SESS_BY_USER_STAT_DET_DAILY

Cursor sessStat is (select 
  TO_CHAR(SYSDATE,'YYYY-MM-DD') DAY, st.SID,st.VALUE,sess.USERNAME,sess.RESOURCE_CONSUMER_GROUP 
from 
  v$session sess, v$sesstat st,v$statname sn 
where 
  sn.NAME='CPU used by this session' and st.STATISTIC#=sn.STATISTIC# and st.SID=sess.SID
  and sess.USERNAME is not null);
  
rSessStat sessStat%ROWTYPE;
isRegisteredSess NUMBER;

BEGIN
  FOR rSessStat in sessStat LOOP
    BEGIN
      Select 1 into isRegisteredSess from SESS_BY_USER_STAT_DET_DAILY where SID=rSessStat.SID and USERNAME=rSessStat.USERNAME;
      EXCEPTION WHEN NO_DATA_FOUND THEN isRegisteredSess := 0;
    END;
    IF isRegisteredSess = 0 THEN
      Insert into SESS_BY_USER_STAT_DET_DAILY  values(TO_DATE(rSessStat.DAY,'YYYY-MM-DD'),rSessStat.SID,rSessStat.VALUE,rSessStat.USERNAME,rSessStat.RESOURCE_CONSUMER_GROUP);
    ELSE
      Update SESS_BY_USER_STAT_DET_DAILY set VALUE=rSessStat.VALUE where SID=rSessStat.SID and USERNAME=rSessStat.USERNAME;
    END IF;
  END LOOP;
  commit;
  
END;

--Select * from SESS_BY_USER_STAT_DET_DAILY




/* CREATE OR REPLACE FORCE VIEW "CORP_BY_DAY_STATS" ("CORPORATION", "DAY", "PERCENTCPU")
AS
  SELECT det.CORPORATION,
    det.DAY,
    ROUND(((det.VALUE/sm.VALUE) * 100)) PercentCPU
  FROM
    (SELECT NVL(uc.CORPORATION,'OTHER') CORPORATION,
      cpubd.DAY,
      SUM(cpubd.VALUE) VALUE
    FROM USER_CORPORATION uc RIGHT JOIN
      CPU_BY_RSRCGRP_USER_DAY cpubd
    ON uc.USERNAME=cpubd.USERNAME
    GROUP BY uc.CORPORATION,
      cpubd.DAY
    ) det,
    (SELECT DAY,SUM(VALUE) VALUE FROM CPU_BY_RSRCGRP_USER_DAY GROUP BY DAY
    ) sm
  WHERE det.DAY=sm.DAY;
*/

CREATE OR REPLACE FORCE VIEW "CORP_BY_DAY_STATS" ("CORPORATION", "DAY", "PERCENTCPU")
AS
  SELECT det.CORPORATION,
    det.DAY,
    ROUND(((det.VALUE/sm.VALUE) * 100)) PercentCPU
  FROM
    (Select t1.DAY,NVL(corp.corporation,'OTHER') CORPORATION, t1.VALUE from (
      SELECT NVL(uc.ID,-1) ID,
      cpubd.DAY,
      SUM(cpubd.VALUE) VALUE
    FROM USER_CORPORATION uc RIGHT JOIN
      CPU_BY_RSRCGRP_USER_DAY cpubd
    ON uc.USERNAME=cpubd.USERNAME
    GROUP BY uc.ID,
      cpubd.DAY)  t1 LEFT join CORPORATIONS corp on t1.ID=corp.ID
    ) det,
    (SELECT DAY,SUM(VALUE) VALUE FROM CPU_BY_RSRCGRP_USER_DAY GROUP BY DAY
    ) sm
  WHERE det.DAY=sm.DAY;
  
CREATE OR REPLACE PROCEDURE AGGREGATE_CPU_STATS_BY_DAY(F_DAY DATE DEFAULT SYSDATE) AS
BEGIN
Insert into 
  CPU_BY_RSRCGRP_USER_DAY 
select 
  RESOURCE_CONSUMER_GROUP, USERNAME, 
  TO_DATE(TO_CHAR(F_DAY-1,'YYYY-MM-DD') || '00:00:00','YYYY-MM-DD HH24:MI:SS'),
  sum(VALUE) 
from 
  sess_by_user_stat_det_daily 
where DAY between 
  TO_DATE(TO_CHAR(F_DAY-1,'YYYY-MM-DD') || '00:00:00','YYYY-MM-DD HH24:MI:SS') and
  TO_DATE(TO_CHAR(F_DAY,'YYYY-MM-DD') || '00:00:00','YYYY-MM-DD HH24:MI:SS') GROUP BY RESOURCE_CONSUMER_GROUP, USERNAME;
  --Delete from sess_by_user_stat_det_daily where DAY <= SYSDATE - 365;
  commit;
end;

create or replace
PROCEDURE AGGREGATE_CPU_STATS_BY_DAY_ALL AS
BEGIN
  insert into CPU_BY_RSRCGRP_USER_HIST(RESOURCE_CONSUMER_GROUP,USERNAME,DAY, VALUE) Select * from CPU_BY_RSRCGRP_USER_DAY;
  delete from CPU_BY_RSRCGRP_USER_DAY;
Insert into 
  CPU_BY_RSRCGRP_USER_DAY
Select 
  RESOURCE_CONSUMER_GROUP, USERNAME,
  TO_DATE(TO_CHAR(DAY,'YYYY-MM-DD'),'YYYY-MM-DD'),SUM(VALUE)
from
  sess_by_user_stat_det_daily
where
  TO_DATE(TO_CHAR(DAY,'YYYY-MM-DD'),'YYYY-MM-DD') < TO_DATE(TO_CHAR(SYSDATE,'YYYY-MM-DD'),'YYYY-MM-DD')
group by 
  TO_DATE(TO_CHAR(DAY,'YYYY-MM-DD'),'YYYY-MM-DD'),RESOURCE_CONSUMER_GROUP,USERNAME
order by 3,1,2;
commit;
end;


begin
 dbms_scheduler.create_schedule(
   schedule_name=>'GATHER_CPU_STAT_SCHEDULE',
   start_date => SYSTIMESTAMP,
   repeat_interval => 'freq=SECONDLY; interval=30',
   end_date => NULL,
   comments => 'Schedule for GATHER_CPU_STATS_BY_SESSION every 30 seconds');
end;


begin
  dbms_scheduler.create_program(
    program_name => 'GATHER_CPU_STAT_PROG',
    program_type => 'STORED_PROCEDURE',
    program_action => 'GATHER_CPU_STATS_BY_SESSION',
    enabled => true,
    COMMENTS => 'Program for GATHER_CPU_STATS_BY_SESSION');
end;


begin
  dbms_scheduler.create_job(
    job_name => 'GATHER_CPU_STAT_JOB',
    program_name => 'GATHER_CPU_STAT_PROG',
    schedule_name => 'GATHER_CPU_STAT_SCHEDULE',
    enabled => TRUE,
    comments => 'JOB FOR GATHER_CPU_STATS_BY_SESSION defined with program GATHER_CPU_STAT_PROG and schedule GATHER_CPU_STAT_SCHEDULE');
end;




begin
 dbms_scheduler.create_schedule(
   schedule_name=>'AGGREGATE_CPU_STATS_SCHEDULE',
   start_date => to_timestamp_tz('2012-04-24 00:15','YYYY-MM-DD HH24:MI'),
   repeat_interval => 'freq=DAILY; byhour=00;byminute=15',
   end_date => NULL,
   comments => 'Schedule for GATHER_CPU_STATS_BY_SESSION every 30 seconds');
end;

begin
  dbms_scheduler.create_program(
    program_name => 'AGGREGATE_CPU_STATS_PROG',
    program_type => 'STORED_PROCEDURE',
    program_action => 'AGGREGATE_CPU_STATS_BY_DAY',
    enabled => true,
    COMMENTS => 'Program for Aggregating sess_by_user_stat_det_daily');
end;

begin
  dbms_scheduler.create_job(
    job_name => 'AGGREGATE_CPU_STATS_JOB',
    program_name => 'AGGREGATE_CPU_STATS_PROG',
    schedule_name => 'AGGREGATE_CPU_STATS_SCHEDULE',
    enabled => TRUE,
    comments => 'JOB FOR AGGREGATE_CPU_STATS_BY_DAY defined with program AGGREGATE_CPU_STATS_PROG and schedule AGGREGATE_CPU_STATS_SCHEDULE');
end;

Select det.CORPORATION, det.DAY,ROUND(((det.VALUE/sm.VALUE)  * 100)) PercentCPU from
(Select 
  uc.CORPORATION, cpubd.DAY, SUM(cpubd.VALUE) VALUE
from 
  USER_CORPORATION uc, CPU_BY_RSRCGRP_USER_DAY  cpubd
where 
 uc.USERNAME=cpubd.USERNAME
group by
  uc.CORPORATION,cpubd.DAY) det,
(Select
   DAY,sum(VALUE) VALUE
 from CPU_BY_RSRCGRP_USER_DAY group by DAY) sm
where det.DAY=sm.DAY


/*
Insert into CORPORATIONS values(1,'PELION S.A.');
Insert into CORPORATIONS values(2,'BSS S.A.');
Insert into CORPORATIONS values(3,'HURT S.A.');
Insert into CORPORATIONS values(4,'CEFARM S.A.');
Insert into CORPORATIONS values(5,'PHARMAPOINT Sp. Z O.O.');
Insert into CORPORATIONS values(6,'PHARMNA LINK Sp. Z O.O.');
Insert into CORPORATIONS values(7,'PHARMA PARTNER');
Insert into CORPORATIONS values(8,'DARUME SP. Z O.O.');
Insert into CORPORATIONS values(9,'PHARMENA S.A.');
Insert into CORPORATIONS values(10,'AB8 Sp. Z O.O.');
Insert into CORPORATIONS values(11,'AB7 Sp. Z O.O.');
Insert into CORPORATIONS values(12,'FARM-SERWIS  Sp. Z O.O.');
Insert into CORPORATIONS values(13,'EUBIOCO S.A.');
Insert into CORPORATIONS values(14,'ePRUF S.A.');
Insert into CORPORATIONS values(15,'URTICA');
Insert into CORPORATIONS values(16,'DOZ S.A.');

DECLARE
Cursor c1 is select distinct USERNAME from SESS_BY_USER_STAT_DET_DAILY;
r1 c1%ROWTYPE;
cId NUMBER;
BEGIN
  FOR r1 in c1 LOOP
    Select ROUND(dbms_random.value(1,16)) into cId from dual;
    insert into user_corporation_new values(r1.USERNAME,cId);
  END LOOP;
commit;
  EXCEPTION WHEN OTHERS THEN dbms_output.put_line('ID = ' || cId || ' user = ' || r1.USERNAME);
END;

*/
