#!/bin/bash

. /home/radek/.bash_profile

if [ $# -ne 1 -a $# -ne 2 ]; then
  echo "[Usage:] ./getPieDataSummary.sh CN [DATE]";
  exit 1;
fi;

LOG_NAME=/var/tmp/oracle/generate_images.log
INPUT_DATA=/tmp/inputData.txt

cn=$1

testavail=`sqlplus -S /nolog <<EOF
set head off pagesize 0 echo off verify off feedback off heading off
connect workload_mon/zebra12@$cn
select trim(1) result from dual;
exit;
EOF`

if [ "$testavail" != "1" ]; then
  echo "Baza $cn niedostepna , wychodze !!" >> $LOG_NAME
else
  echo "Baza $cn dostepna , generuje data points dla SUMMARY" >> $LOG_NAME
fi;

if [ $# -eq 2 ]; then
  PREVIOUS_DAY=$2
else
  PREVIOUS_DAY=$(date -d '-1 day' +'%Y-%m-%d')
fi;


sqlplus /nolog << EOF
connect workload_mon/zebra12@$cn
set head off pagesize 0 echo off verify off feedback off heading off
col CORPORATION format a35
spool $INPUT_DATA
Select
  '#' || Round(CORP_CPU.PERCENTCPU/CORP_CPU_SUMMARY.SUMCPU * 100) || '#' || CORP_CPU.CORPORATION || '#'
from
(Select
  CORPORATION, SUM(PERCENTCPU) PERCENTCPU
from
  CORP_BY_DAY_STATS
where DAY <= TO_DATE('$PREVIOUS_DAY','YYYY-MM-DD')
group by CORPORATION) CORP_CPU,
(Select
  SUM(PERCENTCPU) SUMCPU
from
  CORP_BY_DAY_STATS where DAY <= TO_DATE('$PREVIOUS_DAY','YYYY-MM-DD')) CORP_CPU_SUMMARY;
spool off
EOF

sed -i '1,13d' $INPUT_DATA
sed -i '$d' $INPUT_DATA

awk -F"#" '{ printf "%s;%s\n",$2,$3 }' /tmp/inputData.txt > summary_${cn}_${PREVIOUS_DAY}.csv
