#!/bin/bash

. /home/radek/.bash_profile

LOG_NAME=/var/tmp/oracle/generate_images.log;

array_cn=("HAL_LODZ" "T1HP42OL");

for cn in "${array_cn[@]}"
do
  testavail=`sqlplus -S /nolog <<EOF
  set head off pagesize 0 echo off verify off feedback off heading off
  connect workload_mon/zebra12@$cn
  select trim(1) result from dual;
  exit;
  EOF`
  
  if [ "$testavail" != "1" ]; then
    echo "Baza $cn niedostepna , wychodze !!" >> $LOG_NAME
  else
    echo "Baza $cn dostepna , generuje data points dla DETAILS" >> $LOG_NAME
  fi;

  mindate=`sqlplus -S /nolog <<EOF
  set head off pagesize 0 echo off verify off feedback off heading off
  connect workload_mon/zebra12@$cn
  SELECT TO_CHAR(MIN(DAY),'YYYY-MM-DD') MIN_DAY FROM CPU_BY_RSRCGRP_USER_DAY;
  exit;
  EOF` 

  maxdate=`sqlplus -S /nolog <<EOF
  set head off pagesize 0 echo off verify off feedback off heading off
  connect workload_mon/zebra12@$cn
  SELECT TO_CHAR(MAX(DAY),'YYYY-MM-DD') MAX_DAY FROM CPU_BY_RSRCGRP_USER_DAY;
  exit;
  EOF`

  d1=`date -d "$mindate" +%s` 
  d2=`date -d "$maxdate" +%s`

  ddays=$(((d2-d1)/86400))
  for i in $(seq 0 $ddays) 
  do
   PREVIOUS_DAY=`date -d "$mindate + $i day" +%Y-%m-%d` 
   echo "------------------------- $PREVIOUS_DAY $cn-------------------------" >> $LOG_NAME
   if [ ! -d /var/www/html/workload_stats/$PREVIOUS_DAY/$cn ]; then
     mkdir -p /var/www/html/workload_stats/$PREVIOUS_DAY/$cn
     echo "Zakładam katalog /var/www/html/workload_stats/$PREVIOUS_DAY/$cn" >> $LOG_NAME	
    fi;

    DEST_PATH=/var/www/html/workload_stats/$PREVIOUS_DAY/$cn

    /usr/bin/perl redrawPie.pl workload.png triangle.vertices Workload $cn /tmp/inputData.txt details $cn "$PREVIOUS_DAY" >> $LOG_NAME;
    /usr/bin/perl redrawPie.pl workloadsummary.png triangle.vertices Workload $cn /tmp/inputData.txt summary $cn "$PREVIOUS_DAY" >> $LOG_NAME;

    mv workload.png $DEST_PATH
    mv workloadsummary.png $DEST_PATH
    mv details_${cn}_${PREVIOUS_DAY}.csv /var/www/html/workload_stats/tabular
    mv summary_${cn}_${PREVIOUS_DAY}.csv /var/www/html/workload_stats/tabular
    rm -f triangle.vertices
  done;
done;
